package ANNs;
/**
 * @author Orisun
 * date 2011-10-20
 */
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

public class GA {

	int gnome_len; // 染色体长度
	int population; // 种群大小
	int iter_limit = 80; // 迭代终止代数
	double cross_ratio = 0.7; // 交叉率
	double muta_ratio = 0.1; // 变异率

	public GA(int len,int pop) {
		gnome_len = len;
		population=pop;
	}

	//根据父代的基因，经过一轮的交叉和变异，得到子代的基因（神经网络的权重）
	public ArrayList<ArrayList<Double>> run(ArrayList<Genome> parents) {
		ArrayList<ArrayList<Double>> children = new ArrayList<ArrayList<Double>>(
				population);
		// 取出父代中的精英个体(占总数的1/4)
		int elite_num=population/4;
		Collections.sort(parents);
		ArrayList<ArrayList<Double>> elite = new ArrayList<ArrayList<Double>>(elite_num);
		for (int i = 0;i<elite_num;i++) {
			System.out.println("i="+i+"  fit="+parents.get(population-i-1).fitness);
			elite.add(parents.get(population-i-1).arrWeights);
		}
		Collections.shuffle(parents);
		Random r = new Random(System.currentTimeMillis());
		// 单点交叉
		for (int i = 0; i < population - 1; i += 2) {
			if (r.nextDouble() < cross_ratio) {
				// 选择交叉点
				int slice = 0;
				do {
					slice = r.nextInt(gnome_len);
				} while (slice == 0);
				ArrayList<Double> child1 = new ArrayList<Double>(gnome_len);
				ArrayList<Double> child2 = new ArrayList<Double>(gnome_len);
				int j = 0;
				for (; j < slice; j++) {
					child1.add(parents.get(i).arrWeights.get(j));
					child2.add(parents.get(i + 1).arrWeights.get(j));
				}
				for (; j < gnome_len; j++) {
					child1.add(parents.get(i + 1).arrWeights.get(j));
					child2.add(parents.get(i).arrWeights.get(j));
				}
				children.add(child1);
				children.add(child2);
			}
			else{
				children.add(parents.get(i).arrWeights);
				children.add(parents.get(i+1).arrWeights);
			}
		}
		//System.out.println("children.size()="+children.size());
		// 按一定概率用父代精英替换本子代个体
		for (int i = 0; i < elite.size(); i++) {
			if (r.nextDouble() < 0.5) {
				children.set(i, elite.get(i));
			}
		}
		// 变异
		for (int i = 0; i < children.size(); i++) {
			for (int j = 0; j < gnome_len; j++) {
				if (r.nextDouble() < muta_ratio) {
					double w = children.get(i).get(j);
					if (r.nextBoolean())
						w += r.nextDouble();
					else
						w -= r.nextDouble();
					children.get(i).set(j, w);
				}
			}
		}
		return children;
	}
}
